Description: hardening stuff
Author: Herbert Parentes Fortes Neto <hpfn@debian.org>
Last-Update: 2016-07-22
Index: xmlrpc-c-1.33.14/common.mk
===================================================================
--- xmlrpc-c-1.33.14.orig/common.mk
+++ xmlrpc-c-1.33.14/common.mk
@@ -45,8 +45,10 @@ GCC_CXX_WARNINGS = $(GCC_WARNINGS)  -Wsy
 # assertion and crash the program if it isn't really true.  You can add
 # -UNDEBUG (in any of various ways) to override this.
 #
-CFLAGS_COMMON = -DNDEBUG
-CXXFLAGS_COMMON = -DNDEBUG
+CPPFLAGS_COMMON = -D_FORTIFY_SOURCE=2
+CFLAGS_COMMON = $(CPPFLAGS_COMMON) -DNDEBUG -fPIE
+CXXFLAGS_COMMON = $(CPPFLAGS_COMMON) -DNDEBUG -fPIE
+
 
 ifeq ($(C_COMPILER_GNU),yes)
   CFLAGS_COMMON += $(GCC_C_WARNINGS) -fno-common -g -O3
@@ -84,7 +86,7 @@ ifneq ($(LADD),)
   LDFLAGS := $(LADD)
 endif
 
-LDFLAGS_ALL = $(LDFLAGS_PERSONAL) $(LDFLAGS)
+LDFLAGS_ALL = $(LDFLAGS_PERSONAL) $(LDFLAGS) -fPIE -pie -Wl,-z,now
 
 ##############################################################################
 #                        STATIC LINK LIBRARY RULES                           #
@@ -160,10 +162,10 @@ LDFLAGS_SHLIB_ALL=$(LDFLAGS_ALL) $(LDFLA
 
 #------ the actual rules ----------------------------------------------------
 $(TARGET_SHARED_LIBRARIES) dummyshlib:
-	$(CCLD) $(LDFLAGS_SHLIB_ALL) $(LIBOBJECTS) $(LIBDEP) -o $@  
+	$(CCLD) $(CPPFLAGS_COMMON) $(LDFLAGS_SHLIB_ALL) $(LIBOBJECTS) $(LIBDEP) -o $@
 
 $(TARGET_SHARED_LIBS_PP) dummyshlibpp:
-	$(CXXLD) $(LDFLAGS_SHLIB_ALL) $(LIBOBJECTS) $(LIBDEP) -o $@  
+	$(CXXLD) $(CPPFLAGS_COMMON) $(LDFLAGS_SHLIB_ALL) $(LIBOBJECTS) $(LIBDEP) -o $@
 #----------------------------------------------------------------------------
 
 LIBXMLRPC_UTIL_DIR = $(BLDDIR)/lib/libutil
@@ -305,7 +307,6 @@ CFLAGS_ALL = $(CFLAGS_COMMON) $(CFLAGS_L
 CXXFLAGS_ALL = $(CXXFLAGS_COMMON) $(CFLAGS_LOCAL) \
   $(INCLUDES) $(CFLAGS_PERSONAL) $(CXXFLAGS)
 
-
 $(TARGET_MODS:%=%.o):%.o:%.c
 	$(CC) -c -o $@ $(CFLAGS_ALL) $<
 
@@ -315,7 +316,7 @@ $(TARGET_MODS:%=%.osh):%.osh:%.c
 	$(CC) -c -o $@ $(INCLUDES) $(CFLAGS_ALL) $(CFLAGS_SHLIB) $<
 
 $(TARGET_MODS_PP:%=%.o):%.o:%.cpp
-	$(CXX) -c -o $@ $(INCLUDES) $(CXXFLAGS_ALL) $<
+	$(CXX) -c -o $@ $(INCLUDES) $(CXXFLAGS_ALL) -fPIE $<
 
 $(TARGET_MODS_PP:%=%.osh): CXXFLAGS_COMMON += $(CFLAGS_SHLIB)
 
